<!DOCTYPE html>
<html lang="es">
<head>
    <meta charset="UTF-8">
    <meta http-equiv="X-UA-Compatible" content="IE=edge">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <title>Capitulo_3</title>
</head>
<body>
    <h1>Capitulo 4</h1>
    <a>Ejercicio 3</a>

    <script>

        class Node {
            constructor(val) {
                this.data = val;
                this.left = null;
                this.right = null;
            }
        }   

        const nuevaLista = (data) => {
            let temp = new Node(data);
            return temp
        }

        const remplazarNodo  = (node, profund) => {

            if (node === null) {
                return;
            }
                
            node.data = profund;
            remplazarNodo(node.left, profund + 1);
            remplazarNodo(node.right, profund + 1);
        }

        const imprimirNodo = (node) => {
            if (node === null) {
                return;
            }

            imprimirNodo(node.left);
            console.log(node.data + " ");
            imprimirNodo(node.right);
        }

        let root = new Node();
        root = nuevaLista(3);
        root.left = nuevaLista(2);
        root.right = nuevaLista(5);
        root.left.left = nuevaLista(1);
        root.left.right = nuevaLista(4);

        imprimirNodo(root);
        remplazarNodo(root,0);
        console.log("---------------")
        imprimirNodo(root);
    
        
    </script>
    
</body>
</html>